C=======================================================================
C       TEST     PROGRAM
C=====================================================================
	PROGRAM       MAIN
        IMPLICIT      NONE
        REAL*8      RSX,A1X,A2X,B1X,VX
       
        WRITE(*,*)'INPUT RS(IN ANANGSTROM):'
        READ(*,*)RSX
        WRITE(*,*)'INPUT A1(IN DEGREE):'
        READ(*,*)A1X
        WRITE(*,*)'INPUT A2(IN DEGREE):'
        READ(*,*)A2X
        WRITE(*,*)'INPUT B1(IN DEGREE):'
        READ(*,*)B1X

        CALL POTENTX(RSX,A1X,A2X,B1X,VX)

        WRITE(*,'5F15.5')RSX,A1X,A2X,B1X,VX

        STOP
        END
CC=====================================================================
       MODULE    MODGEN
       IMPLICIT  NONE
       REAL*8,   PARAMETER :: RDEL=0.08
       INTEGER,  PARAMETER :: NPOW=6,NBAS=6
       INTEGER,  PARAMETER :: NR0DAT=24,NA1DAT=13
     &                       ,NA2DAT=13,NB1DAT=13
       REAL*8    V0(NR0DAT,NA1DAT,NA2DAT,NB1DAT)
     &           ,V1(NR0DAT,NA1DAT,NA2DAT)
     &           ,V2(NR0DAT,NA1DAT),V3(NR0DAT)
       REAL*8    R0DAT(NR0DAT),A1DAT(NA1DAT)
     &           ,A2DAT(NA2DAT),B1DAT(NB1DAT)
       END       MODULE
CC====================================================================
C===================================================================
C      SUBROUTINE   POTENTX        
C THIS ROUTINE IS TO GENERATE THE INTERMOLECULAR POTENTIAL ENERGY 
C OF CO2-H2 VAN DER WAALS COMPLEX USING INTERPOLATION METHOD.
C 
C INPUT: FOUR INTERNAL COORDINATES
C --RS: R IN PAPER, UNIT IN ANGSTROM,RS<=8.0
C --A1: THELTA1 IN PAPER, UNIT IN DEGREE
C --A2: THELTA2 IN PAPER, UNIT IN DEGREE
C --B1: PHI IN PAPER, UNIT IN DEGREE

C OUTPUT: THE POTENTIAL ENERGY OF CO2-H2 COMPLEX IN CM-1
CC==========================================================================	
       SUBROUTINE  POTENTX(RSX,A1X,A2X,B1X,VX)
       USE MODGEN, ONLY : RDEL,NPOW,NBAS
       USE MODGEN, ONLY : NR0DAT,NA1DAT,NA2DAT,NB1DAT
       USE MODGEN, ONLY : V0,V1,V2,V3
       USE MODGEN, ONLY : R0DAT,A1DAT,A2DAT,B1DAT
       IMPLICIT    NONE
       REAL*8      RSX,A1X,A2X,B1X,VX
     &             ,VB1(NB1DAT),VA1(NA1DAT),VA2(NA2DAT)
       INTEGER     IR0DAT,IA1DAT,IA2DAT,IB1DAT,MEMSTAT
       REAL*8      SA1,SA2,SBS,T,DS,DDS
       REAL*8      DY(MAX(NA1DAT,NA2DAT,NB1DAT))
     &            ,DDY(MAX(NA1DAT,NA2DAT,NB1DAT))
     &            ,H(MAX(NA1DAT,NA2DAT,NB1DAT))

      
       OPEN(18,FILE='POT.DAT')
       CALL  READV(NR0DAT,NA1DAT,NA2DAT,NB1DAT,
     &              R0DAT,A1DAT,A2DAT,B1DAT,V0)
       

        DO 1100 IA2DAT=1,NA2DAT
        DO 1100 IA1DAT=1,NA1DAT
        DO 1100 IR0DAT=1,NR0DAT
           DO IB1DAT=1,NB1DAT
              VB1(IB1DAT)=V0(IR0DAT,IA1DAT,IA2DAT,IB1DAT)
           ENDDO
           CALL ESPL1(B1DAT,VB1
     &               ,13,0,0,B1X,1,DY,DDY,SBS,DS,DDS,T,H)
            V1(IR0DAT,IA1DAT,IA2DAT)=SBS
 1100   CONTINUE      
 
        DO 1200 IA1DAT=1,NA1DAT
        DO 1200 IR0DAT=1,NR0DAT
           DO IA2DAT=1,NA2DAT
              VA2(IA2DAT)=V1(IR0DAT,IA1DAT,IA2DAT)
           ENDDO
           CALL ESPL1(A2DAT,VA2
     &                ,13,0,0,A2X,1,DY,DDY,SA2,DS,DDS,T,H)
           V2(IR0DAT,IA1DAT)=SA2
 1200   CONTINUE
     
        DO 1300 IR0DAT=1,NR0DAT
           DO IA1DAT=1,NA1DAT
               VA1(IA1DAT)=V2(IR0DAT,IA1DAT)
           ENDDO
           CALL ESPL1(A1DAT,VA1
     &              ,13,0,0,A1X,1,DY,DDY,SA1,DS,DDS,T,H)
           V3(IR0DAT)=SA1
 1300   CONTINUE

        CALL SUBMLS(RDEL,RSX,NR0DAT,R0DAT,V3,VX)
        
        RETURN
        END


CC ===============================================================
       SUBROUTINE READV(NR0DAT,NA1DAT,NA2DAT,NB1DAT,
     &                     R0DAT,A1DAT,A2DAT,B1DAT,V0)
       IMPLICIT               NONE
       CHARACTER*80           ACARD
       INTEGER                 IR0,IA1,IA2,IB1
       INTEGER                IR0DAT,IA1DAT,IA2DAT,IB1DAT
       INTEGER                NR0DAT,NA1DAT,NA2DAT,NB1DAT
       REAL*8                 R0DAT(NR0DAT),A1DAT(NA1DAT),
     &                        A2DAT(NA2DAT),B1DAT(NB1DAT),
     &                        A1DATST((NA1DAT+1)/2),
     &                        A2DATST((NA2DAT+1)/2),
     &                        B1DATST((NB1DAT+1)/2),
     &                        VST(NR0DAT,(NA1DAT+1)/2,
     &                         (NA2DAT+1)/2,(NB1DAT+1)/2),
     &               V00(NR0DAT,NA1DAT,NA2DAT,(NB1DAT+1)/2)
     &                     ,V0(NR0DAT,NA1DAT,NA2DAT,NB1DAT)
        REAL*8     A1X,A2X,B1X
        INTEGER    JA1DAT,JA2DAT,JB1DAT



         
         DO 2100 IR0DAT=1,NR0DAT
         DO 2100 IA1DAT=1,(NA1DAT+1)/2
         DO 2100 IA2DAT=1,(NA2DAT+1)/2
         DO 2100 IB1DAT=1,(NB1DAT+1)/2
            READ(18,*)R0DAT(IR0DAT),A1DATST(IA1DAT),
     &          A2DATST(IA2DAT),B1DATST(IB1DAT),
     &           VST(IR0DAT,IA1DAT,IA2DAT,IB1DAT)
            V00(IR0DAT,IA1DAT,IA2DAT,IB1DAT)=
     &                 VST(IR0DAT,IA1DAT,IA2DAT,IB1DAT)
 2100    CONTINUE
 
        DO IA1DAT=1,(NA1DAT+1)/2
           A1DAT(IA1DAT)=A1DATST(IA1DAT)
           A1DAT(NA1DAT+1-IA1DAT)=180.0-A1DATST(IA1DAT)
        ENDDO
        DO IA2DAT=1,(NA2DAT+1)/2
           A2DAT(IA2DAT)=A2DATST(IA2DAT)
           A2DAT(NA2DAT+1-IA2DAT)=180.0-A2DATST(IA2DAT)
        ENDDO
        DO IB1DAT=1,(NB1DAT+1)/2
           B1DAT(IB1DAT+(NB1DAT-1)/2)=B1DATST(IB1DAT)
           B1DAT(IB1DAT)=0.0-B1DATST((NB1DAT+1)/2-IB1DAT+1)
        ENDDO

        DO 2200 IR0DAT=1,NR0DAT
        DO 2200 IB1DAT=1,(NB1DAT+1)/2
        DO 2200 IA1DAT=1,(NA1DAT-1)/2
        DO 2200 IA2DAT=1,(NA2DAT-1)/2
                A1X=A1DAT(IA1DAT)
                JA1DAT=NINT((180.0D0-A1X)/15.0D0)+1
                A2X=A2DAT(IA2DAT)
                JA2DAT=NINT((180.0D0-A2X)/15.0D0)+1
                V00(IR0DAT,JA1DAT,JA2DAT,IB1DAT)
     &             =VST(IR0DAT,IA1DAT,IA2DAT,IB1DAT)

 2200   CONTINUE
     
       DO 2300 IR0DAT=1,NR0DAT
       DO 2300 IB1DAT=1,(NB1DAT+1)/2
       DO 2300 IA2DAT=1,(NA2DAT+1)/2
       DO 2300 IA1DAT=1,(NA1DAT-1)/2
               A1X=A1DAT(IA1DAT)
               JA1DAT=NINT((180.0D0-A1X)/15.0D0)+1
               B1X=B1DATST(IB1DAT)
               JB1DAT=NINT((180.0D0-B1X)/30.0D0)+1
               V00(IR0DAT,JA1DAT,IA2DAT,JB1DAT)
     &             =VST(IR0DAT,IA1DAT,IA2DAT,IB1DAT)

 2300 CONTINUE

       DO 2400 IR0DAT=1,NR0DAT
       DO 2400 IB1DAT=1,(NB1DAT+1)/2
       DO 2400 IA1DAT=1,(NA1DAT+1)/2
       DO 2400 IA2DAT=1,(NA2DAT-1)/2
              A2X=A2DAT(IA2DAT)
              JA2DAT=NINT((180.0D0-A2X)/15.0D0)+1
              B1X=B1DATST(IB1DAT)
             JB1DAT=NINT((180.0D0-B1X)/30.0D0)+1
             V00(IR0DAT,IA1DAT,JA2DAT,JB1DAT)
     &           =VST(IR0DAT,IA1DAT,IA2DAT,IB1DAT)
 2400  CONTINUE

       DO 2500 IR0DAT=1,NR0DAT
       DO 2500 IA1DAT=1,NA1DAT
       DO 2500 IA2DAT=1,NA2DAT
       DO 2500 IB1DAT=1,(NB1DAT+1)/2
               V0(IR0DAT,IA1DAT,IA2DAT,
     &              IB1DAT+(NB1DAT-1)/2)
     &             =V00(IR0DAT,IA1DAT,IA2DAT,IB1DAT)
               V0(IR0DAT,IA1DAT,IA2DAT,IB1DAT)=
     &               V00(IR0DAT,IA1DAT,IA2DAT,
     &             (NB1DAT+1)/2-IB1DAT+1)
 2500  CONTINUE


 9000  FORMAT(A80)
 9111  FORMAT(4F10.3,F25.5)
       RETURN
       END

CC========================================================================
       SUBROUTINE SUBMLS(XDEL,RX,NDAT,
     &                    XDAT,VDAT,VX)
       USE MODGEN, ONLY : NPOW,NBAS
       IMPLICIT NONE
       INTEGER :: NDAT,NODES,MEMSTAT
       REAL*8  :: VX,RX,XDAT(NDAT)
     &                      ,VDAT(NDAT),XDEL

       INTEGER,ALLOCATABLE :: IPIV(:)
       REAL*8, ALLOCATABLE :: WMAT(:),BMAT(:,:),
     &                        AMAT(:),CMAT(:,:),DMAT(:)


       ALLOCATE(
     &          WMAT(NDAT),BMAT(NBAS,NDAT),IPIV(NBAS),
     &          AMAT(NBAS),CMAT(NBAS,NBAS),DMAT(NBAS),
     &                                     STAT=MEMSTAT)
       IF (MEMSTAT.NE.0) STOP 'FAIL TO ALLOCATE MEMORY IN REFPOTX'
             CALL REFWMAT(XDEL,NDAT,XDAT,WMAT,RX)
             CALL REFBMAT(NDAT,NBAS,XDAT,BMAT,RX)
             CALL MLSMAIN(NDAT,NBAS,WMAT,BMAT,VDAT,
     &                           AMAT,CMAT,DMAT,IPIV)
             VX=DMAT(1)

       DEALLOCATE(WMAT,BMAT,AMAT,CMAT,DMAT,STAT=MEMSTAT)
       IF (MEMSTAT.NE.0) STOP 'FAIL TO RELEASE MEMORY IN REFPOTX'
       RETURN
       END

CC  ===============================================================

       SUBROUTINE REFWMAT(XDEL,NDAT,XDAT,WMAT,RX)
       USE MODGEN,   ONLY : NPOW
       IMPLICIT NONE
       INTEGER    NDAT,IDAT
       REAL*8  :: XDAT(NDAT),WMAT(NDAT),RX,XI,XDEL

CC
CC.....WEIGHT MATRIX

       DO 2000 IDAT=1,NDAT
          XI=XDAT(IDAT)
          WMAT(IDAT)=1.0D0/(DABS(RX-XI)**2+XDEL**2)**NPOW
 2000  CONTINUE
       RETURN
       END
CC=====================================================================
       SUBROUTINE REFBMAT(NDAT,NBAS,XDAT,BMAT,RX)
       IMPLICIT NONE
       INTEGER :: NBAS,NDAT,IDAT,IBAS
       REAL*8  :: XDAT(NDAT),BMAT(NBAS,NDAT),RX,XI
CC
       DO 2000 IDAT=1,NDAT
          XI=XDAT(IDAT)
          DO 1600 IBAS=1,NBAS
             BMAT(IBAS,IDAT)=(XI-RX)**(IBAS-1)
 1600     CONTINUE
 2000  CONTINUE
       RETURN
       END
CC=====================================================================
       SUBROUTINE MLSMAIN(NDAT,NBAS,WMAT,BMAT,VDAT,
     &                           AMAT,CMAT,DMAT,IPIV)
       IMPLICIT NONE
       INTEGER :: NDAT,NBAS,IPIV(NBAS),IBAS,JBAS,IDAT,INFO
       REAL*8  :: WMAT(NDAT),BMAT(NBAS,NDAT),VDAT(NDAT),
     &            AMAT(NBAS),CMAT(NBAS,NBAS),DMAT(NBAS),CIJ,DI
CC
       DO 2000 JBAS=1,NBAS
       DO 2000 IBAS=1,NBAS
          CIJ=0
          DO 1800 IDAT=1,NDAT
             CIJ=CIJ+WMAT(IDAT)*BMAT(IBAS,IDAT)*BMAT(JBAS,IDAT)
 1800     CONTINUE
          CMAT(IBAS,JBAS)=CIJ
 2000  CONTINUE
CC
       DO 3000 IBAS=1,NBAS
          DI=0
          DO 2800 IDAT=1,NDAT
             DI=DI+BMAT(IBAS,IDAT)*WMAT(IDAT)*VDAT(IDAT)
 2800     CONTINUE
          DMAT(IBAS)=DI
 3000  CONTINUE
CC
       CALL DGESV(NBAS,1,CMAT,NBAS,IPIV,DMAT,NBAS,INFO)
       IF (INFO.NE.0) STOP 'FAIL TO TO SLOVE EQUATION IN MLSMAIN'
       RETURN
       END

CC========================================================================
        SUBROUTINE ESPL1(X,Y,N,DY1,DYN,XX,M,DY,DDY,S,DS,DDS,T,H)
        DIMENSION X(N),Y(N),XX(M),DY(N),DDY(N)
        DIMENSION S(M),DS(M),DDS(M),H(N)
        DOUBLE PRECISION X,Y,XX,DY,DDY,S,DS,DDS,H,DY1,DYN,
     *                   T,H0,H1,BETA,ALPHA
        DY(1)=0.0
        H(1)=DY1
        H0=X(2)-X(1)
        DO 10 J=2,N-1
          H1=X(J+1)-X(J)
          ALPHA=H0/(H0+H1)
          BETA=(1.0-ALPHA)*(Y(J)-Y(J-1))/H0
          BETA=3.0*(BETA+ALPHA*(Y(J+1)-Y(J))/H1)
          DY(J)=-ALPHA/(2.0+(1.0-ALPHA)*DY(J-1))
          H(J)=(BETA-(1.0-ALPHA)*H(J-1))
          H(J)=H(J)/(2.0+(1.0-ALPHA)*DY(J-1))
          H0=H1
10      CONTINUE
        DY(N)=DYN
        DO 20 J=N-1,1,-1
20      DY(J)=DY(J)*DY(J+1)+H(J)
        DO 30 J=1,N-1
30      H(J)=X(J+1)-X(J)
        DO 40 J=1,N-1
          H1=H(J)*H(J)
          DDY(J)=6.0*(Y(J+1)-Y(J))/H1-
     *           2.0*(2.0*DY(J)+DY(J+1))/H(J)
40      CONTINUE
        H1=H(N-1)*H(N-1)
        DDY(N)=6.0*(Y(N-1)-Y(N))/H1+
     *            2.0*(2.0*DY(N)+DY(N-1))/H(N-1)
        T=0.0
        DO 50 I=1,N-1
          H1=0.5*H(I)*(Y(I)+Y(I+1))
          H1=H1-H(I)*H(I)*H(I)*(DDY(I)+DDY(I+1))/24.0
          T=T+H1
50      CONTINUE
        DO 70 J=1,M
          IF (XX(J).GE.X(N)) THEN
            I=N-1
          ELSE
            I=1
60          IF (XX(J).GT.X(I+1)) THEN
              I=I+1
              GOTO 60
            END IF
          END IF
          H1=(X(I+1)-XX(J))/H(I)
          S(J)=(3.0*H1*H1-2.0*H1*H1*H1)*Y(I)
          S(J)=S(J)+H(I)*(H1*H1-H1*H1*H1)*DY(I)
          DS(J)=6.0*(H1*H1-H1)*Y(I)/H(I)
          DS(J)=DS(J)+(3.0*H1*H1-2.0*H1)*DY(I)
          DDS(J)=(6.0-12.0*H1)*Y(I)/(H(I)*H(I))
          DDS(J)=DDS(J)+(2.0-6.0*H1)*DY(I)/H(I)
          H1=(XX(J)-X(I))/H(I)
          S(J)=S(J)+(3.0*H1*H1-2.0*H1*H1*H1)*Y(I+1)
          S(J)=S(J)-H(I)*(H1*H1-H1*H1*H1)*DY(I+1)
          DS(J)=DS(J)-6.0*(H1*H1-H1)*Y(I+1)/H(I)
          DS(J)=DS(J)+(3.0*H1*H1-2.0*H1)*DY(I+1)
          DDS(J)=DDS(J)+(6.0-12.0*H1)*Y(I+1)/(H(I)*H(I))
          DDS(J)=DDS(J)-(2.0-6.0*H1)*DY(I+1)/H(I)
70      CONTINUE
        RETURN
        END

